.486p
;		data segment layout
;     var		offset	 size	 comment
;---------------	------	------	---------
;rdbuf			0x0000	0x0200	byte[0x200]
;hufftree_weight	0x0200	0x09D0	dword[0x274]
;hufftree_parent	0x0BD0	0x0EB4	dword[0x273+0x13A]
;hufftree_child		0x1A84	0x09CC	dword[0x273]
;lzwindowbuf		0x2450	0x1000	byte[0x1000]
;				------
;				0x3450

hufftree_weight		equ	0x0200[ebx]
hufftree_parent		equ	0x0BD0[ebx]
hufftree_child		equ	0x1A84[ebx]
lzwindowbuf		equ	0x2450[ebx]

IS_LEAF			equ	0x273*4
LEAF_TO_LITERAL2	equ	-0x273*4
LITERAL2_TO_LEAF	equ	0x273*4
ROOT			equ	0x272*4
MAX_WEIGHT		equ	0x8000

public _lz_v2_read, _lz_v2_init
public _lz_v2_databuffer
public _td_unpack_trk_data, _td_crc_count

ifdef __OS2__
extrn	DosRead:near
else
.errndef __DOS__
endif

_DATA			segment para public 'DATA' use32

_lz_v2_databuffer	dd	0
_lz_v2_hfile		dd	-1
_lz_v2_proc_nextvol	dd	0

_lz_v2_windowbuf_idx	dd	0
_lz_v2_resume_addr	dd	0
_lz_v2_resume_cx	dd	0
_lz_v2_resume_di	dd	0
_lz_v2_eof		dd	0
_lz_v2_diskbf_idx	dd	0
_lz_v2_diskbf_quota	dd	0
_lz_v2_rd_bitbuf	dd	0
_lz_v2_rd_bitbuf_n	dd	0
_DATA			ends

_TEXT			segment para public 'CODE' use32

_lz_v2_init		proc near
			push	ebp
			mov	ebp, esp
			mov	eax, [ebp+8]
			mov	_lz_v2_proc_nextvol, eax
			mov	eax, [ebp+12]
			mov	_lz_v2_hfile, eax
			mov	_lz_v2_resume_addr, 0
			pop	ebp
			retn
_lz_v2_init		endp

_lz_v2_read		proc near
			push	ebp
			mov	ebp, esp
			push	ebx
			push	esi
			push	edi
			mov	edi, [ebp+8]
			mov	ebx, _lz_v2_databuffer
			cmp	_lz_v2_resume_addr, 0
			jz	@@rd_begin
			jmp	_lz_v2_resume_addr

@@rd_begin:		xor	eax, eax
			mov	_lz_v2_eof, eax
			mov	_lz_v2_rd_bitbuf_n, eax
			mov	_lz_v2_rd_bitbuf, eax
			mov	_lz_v2_diskbf_quota, eax
			mov	_lz_v2_diskbf_idx, eax
			call	lz_v2_hufftree_init
			mov	ecx, 0x1000-60
			mov	_lz_v2_windowbuf_idx, ecx
			lea	edi, lzwindowbuf
			mov	eax, 0x20202020
			cld
			shr	ecx, 2
			rep	stosd
@@rd_resume_ch:
			mov	_lz_v2_resume_addr, offset @@rd_resume_ch
			test	_lz_v2_eof, 0xFFFFFFFF
			jz	@@rd_main
			mov	eax, -1
@@rd_ret:
			pop	edi
			pop	esi
			pop	ebx
			pop	ebp
			retn

@@rd_main:		call	lz_v2_rd_getlitrcode
			test	eax, 0xFFFFFF00
			jnz	@@rd_str
			mov	esi, [ebp+8]
			mov	[esi], al
			inc	esi
			mov	[ebp+8], esi
			mov	edi, _lz_v2_windowbuf_idx
			mov	lzwindowbuf[edi], al
			inc	edi
			and	edi, 0xFFF
			mov	_lz_v2_windowbuf_idx, edi
			dec	dword ptr [ebp+12]
			jnz	@@rd_resume_ch
			mov	_lz_v2_resume_addr, offset @@rd_resume_ch
			xor	eax, eax
			jmp	@@rd_ret

@@rd_str:		push	eax
			call	lz_v2_rd_getdistcode
			inc	eax
			mov	edi, _lz_v2_windowbuf_idx
			mov	esi, edi
			sub	edi, eax
			and	edi, 0xFFF
			pop	ecx
			sub	ecx, 0xFD
			mov	edx, [ebp+8]
@@rd_strloop:
			mov	al, lzwindowbuf[edi]
			mov	lzwindowbuf[esi], al
			inc	edi
			inc	esi
			and	edi, 0xFFF
			and	esi, 0xFFF
			mov	[edx], al
			inc	edx
			dec	dword ptr [ebp+12]
			jz	@@rd_strloop_break
@@rd_strloop_continue:	loop	@@rd_strloop
			mov	[ebp+8], edx
			mov	_lz_v2_windowbuf_idx, esi
			jmp	@@rd_resume_ch

@@rd_strloop_break:	mov	_lz_v2_windowbuf_idx, esi
			mov	_lz_v2_resume_cx, ecx
			mov	_lz_v2_resume_di, edi
			mov	_lz_v2_resume_addr, offset @@rd_resume_str
			xor	eax, eax
			jmp	@@rd_ret

@@rd_resume_str:	mov	edx, edi
			mov	esi, _lz_v2_windowbuf_idx
			mov	ecx, _lz_v2_resume_cx
			mov	edi, _lz_v2_resume_di
			jmp	@@rd_strloop_continue
_lz_v2_read		endp

lz_v2_rd_getdistcode	proc near
			call	lz_v2_rd_get8bits
			movzx	edi, al
			movzx	edx, cs:@@distcode_tab_m[edi]
			shl	edx, 6
			movzx	ecx, cs:@@distcode_tab_l[edi]
@@loop:			dec	_lz_v2_rd_bitbuf_n
			jns	@@getbit
			call	lz_v2_rd_pumpbitbuf
@@getbit:		shl	_lz_v2_rd_bitbuf, 1
			rcl	edi, 1
			loop	@@loop
			and	edi, 0x003F
			or	edx, edi
			mov	eax, edx
			retn

@@distcode_tab_l:	db 32 dup(1), 48 dup(2), 64 dup(3), 48 dup(4)
			db 48 dup(5), 16 dup(6)

@@distcode_tab_m:	db 32 dup(0), 16 dup(1), 16 dup(2), 16 dup(3), 8 dup(4)
			db 8 dup(5), 8 dup(6), 8 dup(7), 8 dup(8), 8 dup(9)
			db 8 dup(0Ah), 8 dup(0Bh), 4 dup(0Ch), 4 dup(0Dh)
			db 4 dup(0Eh), 4 dup(0Fh), 4 dup(10h), 4 dup(11h)
			db 4 dup(12h), 4 dup(13h), 4 dup(14h), 4 dup(15h)
			db 4 dup(16h), 4 dup(17h), 2 dup(18h), 2 dup(19h)
			db 2 dup(1Ah), 2 dup(1Bh), 2 dup(1Ch), 2 dup(1Dh)
			db 2 dup(1Eh), 2 dup(1Fh), 2 dup(20h), 2 dup(21h)
			db 2 dup(22h), 2 dup(23h), 2 dup(24h), 2 dup(25h)
			db 2 dup(26h), 2 dup(27h), 2 dup(28h), 2 dup(29h)
			db 2 dup(2Ah), 2 dup(2Bh), 2 dup(2Ch), 2 dup(2Dh)
			db 2 dup(2Eh), 2 dup(2Fh), 30h, 31h, 32h, 33h, 34h
			db 35h, 36h, 37h, 38h, 39h, 3Ah, 3Bh, 3Ch, 3Dh, 3Eh, 3Fh
lz_v2_rd_getdistcode	endp

lz_v2_rd_get8bits	proc near
			mov	ecx, _lz_v2_rd_bitbuf_n
			mov	edx, _lz_v2_rd_bitbuf
			sub	ecx, 8
			jb	@@wanna_more
			shld	eax, edx, 8
			shl	edx, 8
			mov	_lz_v2_rd_bitbuf, edx
			mov	_lz_v2_rd_bitbuf_n, ecx
			retn

@@wanna_more:		call	lz_v2_rd_pumpbitbuf
			add	ecx, 8
			shld	eax, edx, cl
			add	ecx, 24
			mov	_lz_v2_rd_bitbuf_n, ecx
			sub	ecx, 32
			neg	ecx
			mov	edx, _lz_v2_rd_bitbuf
			shld	eax, edx, cl
			shl	edx, cl
			mov	_lz_v2_rd_bitbuf, edx
			retn
lz_v2_rd_get8bits	endp

lz_v2_rd_pumpbitbuf	proc near
@@top:			mov	esi, _lz_v2_diskbf_idx
			cmp	esi, _lz_v2_diskbf_quota
			jae	@@read
			mov	eax, [ebx+esi]
			bswap	eax
			add	esi, 4
			mov	_lz_v2_diskbf_idx, esi
			mov	_lz_v2_rd_bitbuf, eax
			mov	_lz_v2_rd_bitbuf_n, 31
			retn

@@read:			push	ecx
			push	ebx
			push	edx
			push	edi
ifdef __OS2__
			push	eax
			lea	eax, [esp]
			push	eax
			push	0x200
			push	ebx
			push	_lz_v2_hfile
			call	DosRead
			add	esp, 0x10
			test	eax, eax
			pop	eax
			jnz	@@rd_error
endif

ifdef __DOS__
			mov	ecx, 0x200
			mov	edx, ebx
			mov	ebx, _lz_v2_hfile
			mov	eax, 0x3F00
			int	0x21
			jc	@@rd_error
endif

			mov	_lz_v2_diskbf_quota, eax
			mov	_lz_v2_diskbf_idx, 0
			or	eax, eax
			jz	@@rd_error
			pop	edi
			pop	edx
			pop	ebx
			pop	ecx
			jmp	@@top

@@rd_error:		xor	eax, eax
			push	eax
			call	_lz_v2_proc_nextvol
			add	esp, 4
			pop	edi
			pop	edx
			pop	ebx
			pop	ecx
			mov	_lz_v2_hfile, eax
			or	eax, eax
			jns	@@read
			mov	_lz_v2_eof, eax
			mov	_lz_v2_rd_bitbuf, 0
			mov	_lz_v2_rd_bitbuf_n, 31
			retn
lz_v2_rd_pumpbitbuf	endp

lz_v2_rd_getlitrcode	proc near
			mov	edi, hufftree_child[ROOT]
@@test_leaf:		cmp	edi, IS_LEAF
			jae	@@gotleaf
			dec	_lz_v2_rd_bitbuf_n
			jns	@@getbit2
			call	lz_v2_rd_pumpbitbuf
@@getbit2:		xor	edx, edx
			shl	_lz_v2_rd_bitbuf, 1
			rcl	edx, 1
			lea	edi, [edi+edx*4]
			mov	edi, hufftree_child[edi]
			jmp	@@test_leaf

@@gotleaf:		lea	eax, LEAF_TO_LITERAL2[edi]
			push	eax
			call	lz_v2_hufftree_update
			pop	eax
			shr	eax, 2
			retn	  
lz_v2_rd_getlitrcode	endp

lz_v2_hufftree_update	proc near
			mov	esi, eax
			cmp	dword ptr hufftree_weight[ROOT], MAX_WEIGHT
			jnz	@@upd_norebuild
			push	esi
			call	lz_v2_hufftree_rebuild
			pop	esi
@@upd_norebuild:	mov	esi, hufftree_parent[LITERAL2_TO_LEAF][esi]
@@upd_loop:		mov	edx, hufftree_weight[esi]
			inc	edx
			mov	hufftree_weight[esi], edx
			cmp	edx, hufftree_weight[esi+4]
			jbe	@@upd_continue
			lea	edi, hufftree_weight[esi+8]
			mov	eax, edx
@@rep_scasw:		scasd
			ja	@@rep_scasw
			lea	eax, hufftree_weight[8]
			sub	edi, eax

			xchg	edx, hufftree_weight[edi]
			mov	hufftree_weight[esi], edx
			mov	eax, hufftree_child[esi]
			xchg	eax, edi
			mov	hufftree_parent[edi], eax
			cmp	edi, IS_LEAF
			jae	@@leaf_noupd1
			mov	hufftree_parent[edi+4], eax
@@leaf_noupd1:		xchg	eax, edi
			xchg	eax, hufftree_child[edi]
			xchg	eax, edi
			mov	hufftree_parent[edi], esi
			cmp	edi, IS_LEAF
			jae	@@leaf_noupd2
			mov	hufftree_parent[edi+4], esi
@@leaf_noupd2:		mov	hufftree_child[esi], edi
			mov	esi, eax
@@upd_continue:		mov	esi, hufftree_parent[esi]
			test	esi, esi
			jnz	@@upd_loop
			retn
lz_v2_hufftree_update	endp

lz_v2_hufftree_rebuild	proc near
			xor	edi, edi
			xor	esi, esi
			mov	edx, IS_LEAF
			mov	ecx, 4
@@rebld_loop1:		cmp	hufftree_child[edi], edx
			jb	@@rebld_continue1
			mov	eax, hufftree_weight[edi]
			inc	eax
			shr	eax, 1
			mov	hufftree_weight[esi], eax
			mov	eax, hufftree_child[edi]
			mov	hufftree_child[esi], eax
			add	esi, ecx
@@rebld_continue1:	add	edi, ecx
			cmp	edi, edx
			jnz	@@rebld_loop1
			xor	edi, edi
			mov	esi, 274h*2
@@rebld_loop2:		mov	edx, hufftree_weight[edi]
			add	edx, hufftree_weight[edi+4]
			mov	hufftree_weight[esi], edx
			push	edi
			mov	edi, esi
@@rebld_search_weight:	sub	edi, 4
			cmp	edx, hufftree_weight[edi]
			jb	@@rebld_search_weight
			add	edi, 4
			mov	eax, esi
			sub	eax, edi
			push	esi
			push	edi
			std
			add	edi, eax
			shr	eax, 2
			mov	ecx, eax
			push	edi
			lea	edi, hufftree_weight[edi]
			lea	esi, [edi-4]
			rep	movsd
			pop	edi
			mov	ecx, eax
			lea	edi, hufftree_child[edi]
			lea	esi, [edi-4]
			rep	movsd
			cld
			pop	edi
			mov	hufftree_weight[edi], edx
			pop	esi
			pop	eax
			mov	hufftree_child[edi], eax
			mov	edi, eax
			add	edi, 8
			add	esi, 4
			cmp	esi, ROOT
			jbe	@@rebld_loop2
			xor	edi, edi
@@rebld_loop3:		mov	eax, hufftree_child[edi]
			mov	esi, eax
			cmp	eax, IS_LEAF
			jb	@@not_leaf
			mov	hufftree_parent[esi], edi
			jmp	@@rebld_continue3

@@not_leaf:		mov	hufftree_parent[esi], edi
			mov	hufftree_parent[esi+4], edi
@@rebld_continue3:	add	edi, 4
			cmp	edi, ROOT
			jbe	@@rebld_loop3
			retn
lz_v2_hufftree_rebuild	endp

lz_v2_hufftree_init	proc near
			xor	edi, edi
			mov	esi, 4E6h*2
			mov	edx, 4
@@hufinit_loop1:	mov	dword ptr hufftree_weight[edi], 1
			mov	hufftree_child[edi], esi
			mov	hufftree_parent[esi], edi
			add	esi, edx
			add	edi, edx
			cmp	edi, 274h*2
			jnz	@@hufinit_loop1
			xor	edi, edi
			mov	esi, 274h*2
@@hufinit_loop2:	mov	eax, hufftree_weight[edi]
			add	eax, hufftree_weight[edi+4]
			mov	hufftree_weight[esi], eax
			mov	hufftree_child[esi], edi
			mov	hufftree_parent[edi], esi
			mov	hufftree_parent[edi+4], esi
			add	edi, edx
			add	edi, edx
			add	esi, edx
			cmp	esi, 4E4h*2
			jbe	@@hufinit_loop2
			mov	dword ptr hufftree_weight[ROOT+4], 0FFFFh
			mov	dword ptr hufftree_parent[ROOT], 0
			retn
lz_v2_hufftree_init	endp

; ***************************************************************************

_td_unpack_trk_data	proc near
			push	ebp
			mov	ebp, esp
			push	esi
			push	edi
			cld
			mov	esi, [ebp+12]
			mov	edi, [ebp+8]
			movzx	eax, byte ptr [esi+2]
			test	eax, eax
			jz	@@trk_data_tag0
			dec	eax
			jz	@@trk_data_tag1
			dec	eax
			jz	@@trk_data_tag2
@@trk_data_error:	mov	eax, -1
@@trk_data_done:	sub	esi, [ebp+12]
			mov	edi, [ebp+16]
			mov	[edi], esi
			pop	edi
			pop	esi
			pop	ebp
			retn	

@@trk_data_tag0:	lodsw
			dec	eax
			mov	ecx, eax
			js	@@trk_data_error
			inc	esi
			rep	movsb
			jmp	@@trk_data_done

@@trk_data_tag1:	inc	esi
			inc	esi
			inc	esi
			lodsw
			mov	ecx, eax
			cmp	eax, 0x2000
			ja	@@trk_data_error
			push	ecx
			lodsw
			rep	stosw
			pop	eax
			shl	eax, 1
			jmp	@@trk_data_done

@@trk_data_tag2:	lodsw
			mov	edx, eax
			dec	edx
			js	@@trk_data_error
			inc	esi
@@trk_data_tag2_loop:	xor	eax, eax
			lodsb
			dec	edx
			test	eax, eax
			jz	@@trk_data_tag2_st0
			dec	eax
			jnz	@@trk_data_error
			lodsb
			dec	edx
			mov	ecx, eax
			lea	eax, [edi+eax*2]
			sub	eax, 0x4000
			cmp	eax, [ebp+8]
			ja	@@trk_data_error
			lodsw
			dec	edx
			dec	edx
			rep	stosw
@@trk_data_tag2_nxt?:	test	edx, edx
			js	@@trk_data_error
			jnz	@@trk_data_tag2_loop
			mov	eax, edi
			sub	eax, [ebp+8]
			jmp	@@trk_data_done

@@trk_data_tag2_st0:	lodsb
			dec	edx
			mov	ecx, eax
			sub	edx, ecx
			js	@@trk_data_error
			rep	movsb
			jmp	@@trk_data_tag2_nxt?
_td_unpack_trk_data	endp

_td_crc_count		proc near
			push	ebp
			mov	ebp, esp
			push	esi
			mov	esi, [ebp+8]
			mov	ecx, [ebp+12]
			xor	edx, edx
			xor	ax, ax
@@td_crc_loop:		movzx	eax, byte ptr [esi]
			inc	esi
			xor	eax, edx
			shr	edx, 8
			movzx	eax, al
			xor	dx, cs:@@td_crctab[eax*2]
			loop	@@td_crc_loop
			xchg	dh, dl
			movzx	eax, dx
			pop	esi
			pop	ebp
			retn

@@td_crctab	dw 0, 97A0h, 0B9E1h, 2E41h, 0E563h, 72C3h, 5C82h, 0CB22h
		dw 0CAC7h, 5D67h, 7326h, 0E486h, 2FA4h,	0B804h,	9645h, 1E5h
		dw 32Fh, 948Fh,	0BACEh,	2D6Eh, 0E64Ch, 71ECh, 5FADh, 0C80Dh
		dw 0C9E8h, 5E48h, 7009h, 0E7A9h, 2C8Bh,	0BB2Bh,	956Ah, 2CAh
		dw 65Eh, 91FEh,	0BFBFh,	281Fh, 0E33Dh, 749Dh, 5ADCh, 0CD7Ch
		dw 0CC99h, 5B39h, 7578h, 0E2D8h, 29FAh,	0BE5Ah,	901Bh, 7BBh
		dw 571h, 92D1h,	0BC90h,	2B30h, 0E012h, 77B2h, 59F3h, 0CE53h
		dw 0CFB6h, 5816h, 7657h, 0E1F7h, 2AD5h,	0BD75h,	9334h, 494h
		dw 0CBCh, 9B1Ch, 0B55Dh, 22FDh,	0E9DFh,	7E7Fh, 503Eh, 0C79Eh
		dw 0C67Bh, 51DBh, 7F9Ah, 0E83Ah, 2318h,	0B4B8h,	9AF9h, 0D59h
		dw 0F93h, 9833h, 0B672h, 21D2h,	0EAF0h,	7D50h, 5311h, 0C4B1h
		dw 0C554h, 52F4h, 7CB5h, 0EB15h, 2037h,	0B797h,	99D6h, 0E76h
		dw 0AE2h, 9D42h, 0B303h, 24A3h,	0EF81h,	7821h, 5660h, 0C1C0h
		dw 0C025h, 5785h, 79C4h, 0EE64h, 2546h,	0B2E6h,	9CA7h, 0B07h
		dw 9CDh, 9E6Dh,	0B02Ch,	278Ch, 0ECAEh, 7B0Eh, 554Fh, 0C2EFh
		dw 0C30Ah, 54AAh, 7AEBh, 0ED4Bh, 2669h,	0B1C9h,	9F88h, 828h
		dw 8FD8h, 1878h, 3639h,	0A199h,	6ABBh, 0FD1Bh, 0D35Ah, 44FAh
		dw 451Fh, 0D2BFh, 0FCFEh, 6B5Eh, 0A07Ch, 37DCh,	199Dh, 8E3Dh
		dw 8CF7h, 1B57h, 3516h,	0A2B6h,	6994h, 0FE34h, 0D075h, 47D5h
		dw 4630h, 0D190h, 0FFD1h, 6871h, 0A353h, 34F3h,	1AB2h, 8D12h
		dw 8986h, 1E26h, 3067h,	0A7C7h,	6CE5h, 0FB45h, 0D504h, 42A4h
		dw 4341h, 0D4E1h, 0FAA0h, 6D00h, 0A622h, 3182h,	1FC3h, 8863h
		dw 8AA9h, 1D09h, 3348h,	0A4E8h,	6FCAh, 0F86Ah, 0D62Bh, 418Bh
		dw 406Eh, 0D7CEh, 0F98Fh, 6E2Fh, 0A50Dh, 32ADh,	1CECh, 8B4Ch
		dw 8364h, 14C4h, 3A85h,	0AD25h,	6607h, 0F1A7h, 0DFE6h, 4846h
		dw 49A3h, 0DE03h, 0F042h, 67E2h, 0ACC0h, 3B60h,	1521h, 8281h
		dw 804Bh, 17EBh, 39AAh,	0AE0Ah,	6528h, 0F288h, 0DCC9h, 4B69h
		dw 4A8Ch, 0DD2Ch, 0F36Dh, 64CDh, 0AFEFh, 384Fh,	160Eh, 81AEh
		dw 853Ah, 129Ah, 3CDBh,	0AB7Bh,	6059h, 0F7F9h, 0D9B8h, 4E18h
		dw 4FFDh, 0D85Dh, 0F61Ch, 61BCh, 0AA9Eh, 3D3Eh,	137Fh, 84DFh
		dw 8615h, 11B5h, 3FF4h,	0A854h,	6376h, 0F4D6h, 0DA97h, 4D37h
		dw 4CD2h, 0DB72h, 0F533h, 6293h, 0A9B1h, 3E11h,	1050h, 87F0h

_td_crc_count		endp

_TEXT			ends
		end
